		Org	$

ASCII_Out:
	Acall	Hex_ASCII2
	Acall	Serial_Out
	XCH	A,B
	Acall	Serial_Out
	Ret

Out_DPTR:
	Mov	A,DPH
	Acall	ASCII_Out
	Mov	A,DPL
	Acall	ASCII_Out
	Ret

Enter_Code:
	Push	ACC
	Mov	A,#0DH
	Acall	Serial_Out
	Mov	A,#0AH
	Acall	Serial_Out
	Pop	ACC
	Ret

Init_Serial:
	MOV     SCON,#52H        ; Mode 1 Ren
;	MOV	TMOD,#20H        ; T0 Mode 2, T1 Mode 2
;	Mov	A,TMOD
;	Anl	A,#0FH
;	Orl	A,#20H
;	Mov	TMOD,A
	Mov	TMOD,#20h
	MOV	TH1,#0FFH        ; 115200 Baudrate
	Setb	TR1
	MOV     PCON,#80H        ;
	RET   

Serial_Out:
	Clr	TI
	Mov	SBUF,A
TungguKirim:
	Jnb	TI,TungguKirim
	Clr	TI
	Ret
;********************************************************
; SUBROUTINE SERIAL IN DENGAN TIME OUT
SerialInTOut:
	Mov	TH0,#00
	Mov	TL0,#00
	Setb	TR0
	Clr	RI
WaitTout:
	Jnb	RI,CekT0
	Mov	A,SBUF
	Clr	RI
	Ret

CekT0:
	Jnb	TF0,WaitTout
	Clr	TF0
	Clr	RI
	Ret	
		

Serial_In:
	Clr	RI
waitserial:
	Jnb	RI,waitserial
	Mov	A,SBUF
	Clr	RI
	Ret


KirimPesan_Serial:
	Mov	A,#00H
	Movc	A,@A+DPTR
	Cjne	A,#0FH,KirimTerus
	Ret

KirimTerus:
	Acall	Serial_Out
	Inc	DPTR
	Ajmp	KirimPesan_Serial
