;Revisi 31/1/11
;12/08/10
;- Revisi, Bug di Cek NomorHP, memori kosong dianggap nomor valid
;- Tambah fitur Cek Posisi

; V2.6 tambah Delete SMS 11/04/10
; V2.5 tambah cek CREG 10/9/9
; V2.0 tambah ACK OK
; - Kirim Teks


Delete9SMS:
	Mov	R7,#9				;Delete 9 sms terdepan
	Mov	R5,#'1'				;
LoopDeleteSMS:					;
	Mov	IndexSMS,R5			;
	Lcall	DeleteSMS			;
	Inc	R5				;
	Djnz	R7,LoopDeleteSMS		;
	Ret

;===========================================================================
; BACA SMS
; - Kirim perintah AT+CMGR
; - Ambil nomor HP dan simpan di BufferHPTujuan
; - Ambil perintah SMS dan simpan di Buffer Perintah

PesanBacaSMS:
	DB	'AT+CMGR=',0Fh

BacaSMS:
	Mov	DPTR,#PesanBacaSMS		;Kirim perintah Baca SMS
	Lcall	KirimPesan_Serial		;sesuai nomor index
	Mov	A,IndexSMS			;
	Lcall	Serial_Out			;
	Mov	A,#0Dh				;
	Lcall	Serial_Out			;
	Mov	A,#0Ah				;
	Lcall	Serial_Out			;
	Lcall	TungguPetik			;
	Lcall	TungguPetik			;
	Lcall	TungguPetik			;

;---------- AMBIL NO HP YANG MASUK KE HP TUJUAN
	Mov	R0,#BufferHPTujuan
LoopHPTujuan:
	Lcall	Serial_In
	Cjne	A,#'"',LoopHPTujuan2
	Mov	@R0,#00
	Ljmp	AmbilIsiSMS

LoopHPTujuan2:
	Mov	@R0,A
	Inc	R0
	Ljmp	LoopHPTujuan

;---------- AMBIL PERINTAH DI SMS
; - Ambil 16 karakter pertama atau bila ketemu enter
;

AmbilIsiSMS:
	Lcall	TungguEnter
	Mov	R7,#16
	Mov	R0,#BufferPerintah
LoopAmbilIsiSMS:
	Lcall	Serial_In
	Cjne	A,#0DH,BelumSelesaiIsiSMS
	Ljmp	AmbilIsiSMSSelesai

BelumSelesaiIsiSMS:
	Cjne	A,#'(',Masihbelum
	Ljmp	ambilIsiSMSSelesai

MasihBelum:
	Mov	@R0,A
	Inc	R0
	Djnz	R7,LoopAmbilIsiSMS
AmbilIsiSMSSelesai:

	Lcall	WaitOK
	Lcall	TungguEnter
	Ret

TungguPetik:
	Lcall	Serial_In
	Cjne	A,#'"',TungguPetik
	Ret

Tunggutitik2:
	Lcall	Serial_In
	Cjne	A,#':',TungguTitik2
	Ret


Tunggukurungbuka:
	Lcall	Serial_In
	Cjne	A,#'(',Tunggukurungbuka
	Ret

Tungguprompt:
	Mov	B,#00
LoopTungguprompt:
	Lcall	SerialInTout
	Cjne	A,#'>',CekpromptTout
	Ret

CekpromptTout:
	Djnz	B,LoopTungguprompt
	Ret

TungguEnter:
	Lcall	Serial_In
	Cjne	A,#0Dh,TungguEnter
	Lcall	Serial_In
	Cjne	A,#0Ah,TungguEnter
	Ret


TungguEnter2:
	Mov	B,#00
LoopTungguEnter:
	Lcall	SerialInTout
	Cjne	A,#0Dh,CekEnterTout
	Lcall	SerialInTout
	Ret


CekEnterTout:
	Djnz	B,LoopTungguEnter
	Lcall	SerialInTout
	Ret



PesanKirimSMS:
	DB	'AT+CMGS="',0Fh		

;================================================================
; PERINTAH UNTUK SET WAKTU 
; - Baca SMS dan temukan "(" pertama
; - Copy waktu yang dibaca ke buffer waktu
; - Kirim perintah AT+CCLK "waktu"

SetTime:
	Lcall	Tunjukkurungpertama
	Mov	R0,#BufferWaktu
	Mov	R7,#20				;Copy buffer waktu
LoopAmbilWaktu:					;
	Lcall	Serial_In			;
	Mov	@R0,A				;
	Inc	R0
	Djnz	R7,LoopAmbilWaktu		;

	Lcall	TungguEnter
	Lcall	WaitOK

	Mov	DPTR,#PesanSetTime
	Lcall	KirimPesan_Serial	
	Mov	R0,#BufferWaktu
	Mov	R7,#20
LoopSetTime:
	Mov	A,@R0
	Inc	R0
	Lcall	Serial_Out
	Djnz	R7,LoopSetTime
	Mov	A,#'"'
	Lcall	Serial_Out
	Mov	A,#0Dh
	Lcall	Serial_Out
	Mov	A,#0Ah
	Lcall	Serial_Out

	Lcall	WaitOK2
	lcall	TungguEnter
	Ret



PesanSetTime:
	DB	'AT+CCLK="',0Fh


;================================================================
; BAGIAN MELIHAT SETTING WAKTU
; - Baca Waktu 
; - Copy ke outbox dan kirim

ViewTime:
	Lcall	GetTime
	Mov	R0,#BufferOutbox
	Mov	R1,#BufferWaktu
	Mov	R7,#20
	Lcall	CopyRAMtoRAM
	Mov	@R0,#00
	Lcall	KirimSMS
	Ret

;===========================================================================
; BAGIAN MELIHAT ISI PULSA BERDASAR NOMOR OPERATOR

Pulsa:
	Push	IE
	Clr	ES
	Clr	ET0
	Lcall	Delay_1detik
	Lcall	Delay_1detik
	Lcall	Delay_1detik
	Lcall	DeleteSMS

	Mov	DPTR,#PesanDial
	Lcall	KirimPesan_Serial

	Mov	DPTR,#OperatorNumber
LoopOperator:
	Lcall	BacaEEPROM		
	Jz	OperatorSelesai
	Inc	DPTR
	Lcall	Serial_Out
	Ljmp	LoopOperator

OperatorSelesai:

	Mov	A,#'#'
	Lcall	Serial_Out

;	Mov	A,#';'
;	Lcall	Serial_Out
	Mov	A,#0Dh
	Lcall	Serial_Out
	Mov	A,#0Ah
	Lcall	Serial_Out

	
	Lcall	TungguPetik
	Mov	R0,#BufferOutbox
	Mov	R7,#60
LoopAmbilPulsa:
	Lcall	Serial_In
	Cjne	A,#'"',BukanAkhirPulsa
	Ljmp	AkhirPulsa

BukanAkhirPulsa:
	Mov	@R0,A
	Inc	R0
	Djnz	R7,LoopAmbilPulsa
AkhirPulsa:
	Mov	@R0,#0

	Lcall	WaitOK
	Lcall	TungguEnter

	Lcall	KirimSMS
	Pop	IE
	Ret

PesanDial:
	DB	'ATD *',0Fh	

;===========================================================================
; BAGIAN RESET NILAI COUNTER
;Reset:
;	Mov	DPTR,#IOStatus
;	Mov	DataI2C,#0FFh
;	Lcall	TulisDPTRSEE8b
;	Lcall	DelaySEE
;	Lcall	DelaySEE
;	Lcall	DelaySEE
;	Ret

;===========================================================================
; BAGIAN SET NILAI OPERATOR
Operator:
	Lcall	TunjukkurungPertama
	Mov	R0,#RAM_OperatorNumber

LoopGetOperator:
	Lcall	Serial_In
	Cjne	A,#')',BelumAkhirGetOperator
	Ljmp	AkhirGetOperator

BelumAkhirGetOperator:
	Mov	@R0,A
	Inc	R0
	Ljmp	LoopGetOperator	

AkhirGetOperator:
	Mov	@R0,#00
	Lcall	WaitOK
	Lcall	TungguEnter

	Mov	R0,#RAM_OperatorNumber
	Mov	DPTR,#OperatorNumber
	Lcall	CopyRAMtoSEE2
	Mov	A,#00
	Lcall	TulisEEPROM
	Ret	


;===========================================================================
; BAGIAN UNTUK KIRIM OK

OK:
	Mov	DPTR,#PesanOK
	Lcall	KirimTeks
	Ret

PesanOK:
	DB	'OK',0	

;===========================================================================
; BAGIAN UNTUK MENGIRIM TEKS DARI DPTR

KirimTeks:
	Mov	R0,#BufferOutbox
LoopKirimTeks:
	Mov	A,#00
	Movc	A,@A+DPTR
	Jz	TeksOver
	Mov	@R0,A
	Inc	R0
	Inc	DPTR
	Ljmp	LoopKirimTeks

TeksOver:
	Mov	@R0,#00
	Lcall	KirimSMS
	Ret



;===========================================================================
; BAGIAN UNTUK MELIHAT COMPANY PEMBUAT
Company:
	Mov	DPTR,#PesanCompany
	Mov	R0,#BufferOutbox
LoopCompany:
	Mov	A,#00
	Movc	A,@A+DPTR
	Jz	CompanyOver
	Mov	@R0,A
	Inc	R0
	Inc	DPTR
	Ljmp	LoopCompany

CompanyOver:
	Mov	@R0,#00
	Lcall	KirimSMS
	Ret

PesanCompany:
	DB	'DELTA ELECTRONIC',0	

;===========================================================================
; BAGIAN UNTUK SET ID
SetID:
	Lcall	TunjukkurungPertama		
	Lcall	Serial_In			;Ambil nilai ID
	Push	ACC				;
	Lcall	Serial_In			;
	Mov	B,A				;
	Pop	ACC				;
	Lcall	ASCII_Hex			;Konversi ke hex dan save ke RAM
	Mov	RAM_ID,A			;
	Lcall	WaitOK				;
	Lcall	TungguEnter			;

	Mov	DPTR,#ID			;Copy ke memori
	Mov	A,RAM_ID			;
	Lcall	TulisEEPROM			;
	Ret					;

;===========================================================================
; BAGIAN UNTUK MELIHAT ID
ViewID:
	Mov	DPTR,#ID			;Ambil data ID
	Lcall	BacaEEPROM			;
	Lcall	Hex_ASCII2
	Mov	R0,#BufferOutbox		;Simpan di outbox
	Mov	@R0,A				;
	Inc	R0				;
	Mov	@R0,B				;	
	Inc	R0				;
	Mov	@R0,#0				;
	Lcall	KirimSMS			;Kirim ke SMS
	Ret

;===================================================
; BAGIAN MENGIRIMKAN ISI OUTBOX KE HP TUJUAN
; - Isi data di buffer outbox dan beri akhiran 0
; - Panggil subroutine ini

KirimSMS:
	Push	IE
	Mov	DPTR,#PesanKirimSMS		;Kirim AT+CMGS
	Lcall	KirimPesan_Serial		;
	Lcall	KirimHPTujuan			;Kirim no HP Tujuan
	Mov	A,#'"'				;
	Lcall	Serial_Out			;

	Mov	A,#0Dh				;
	Lcall	Serial_Out			;
	Mov	A,#0Ah				;
	Lcall	Serial_Out			;
	Lcall	Tungguprompt

	Mov	R0,#BufferOutBox		;Kirim data di outbox
	Lcall	KirimBuffer			;
	Mov	A,#26				;Ctrl Z
	Lcall	Serial_Out			;


TungguOKnplus:
	Lcall	Serial_In
	Cjne	A,#'+',Wait4OK

;	Lcall	WaitOK
T_Enter:
	Lcall	TungguEnter

	Pop	IE
	ret


Wait4OK:
	Cjne	A,#'O',TungguOKnplus
	Lcall	Serial_In
	Cjne	A,#'K',TungguOKnplus
	Ljmp	T_enter


	Lcall	WaitOK2				;Tunggu SMS terkirim

	Mov	A,#'Z'
	Lcall	Serial_Out



	Lcall	TungguEnter2			;

	Pop	IE
	Ret

;=========================
; KIRIM NOMOR HP TUJUAN

KirimHPTujuan:
	Mov	R0,#BufferHPTujuan		;Kirim no HP Tujuan
	Lcall	KirimBuffer
	Ret

KirimBuffer:
LoopKirimBuffer:
	Mov	A,@R0				;
	Jz	KirimBufferSelesai
	Inc	R0				;
	Lcall	Serial_Out			;
	Ljmp	LoopKirimBuffer
KirimBufferSelesai:
	Ret


;=========================
; GET TIME
GetTime:
	Mov	DPTR,#PesanGetTime
	Lcall	KirimPesan_Serial

	Mov	A,#0Dh
	Lcall	Serial_Out
	Mov	A,#0Ah
	Lcall	Serial_Out
	Mov	R7,#10
X19:
	Lcall	Serial_In
	Djnz	R7,X19

	Mov	R7,#20
	Mov	R0,#BufferWaktu
LoopAmbilBufferWaktu:
	Lcall	Serial_In
	Mov	@R0,A
	Inc	R0
	Djnz	R7,LoopAmbilBufferWaktu
	Lcall	WaitOK
	Lcall	TungguEnter

	Ret		

PesanGetTime:
	DB	'AT+CCLK?',0Fh

;=========================
; DELETE SMS
DeleteSMS:
	Mov	DPTR,#PesanDeleteSMS
	Lcall	KirimPesan_Serial
	Mov	A,IndexSMS
	Lcall	Serial_Out
	Mov	A,#0Dh
	Lcall	Serial_Out
	Mov	A,#0Ah
	Lcall	Serial_Out
	Lcall	WaitOK
	Lcall	TungguEnter
	Ret

PesanDeleteSMS:
	DB	'AT+CMGD=',0Fh

TunjukkurungPertama:
	Mov	DPTR,#PesanBacaSMS		;Kirim perintah Baca SMS
	Lcall	KirimPesan_Serial		;sesuai nomor index
	Mov	A,IndexSMS			;
	Lcall	Serial_Out			;
	Mov	A,#0Dh				;
	Lcall	Serial_Out			;
	Mov	A,#0Ah				;
	Lcall	Serial_Out			;
	Lcall	TungguEnter
	Lcall	Tunggukurungbuka				;
	Ret

;===========================================================================
; BAGIAN PENCARI INDEKS PERINTAH
; - Bila index ketemu = carry flag clear dan nilai index ada di indexperintah dalam hex
; - Bila tidak ketemu = carry flag set

CariIndeksPerintah:
	Mov	DPTR,#TabelPerintah
	Mov	IndexPerintah,#0	

LoopFindPerintah:
	Mov	R0,#BufferPerintah
	Mov	R7,#16
	Lcall	CompareString

	Inc	IndexPerintah
	Push	ACC
	Push	PSW
	Mov	A,#16
	Lcall	AddADPTR
	Pop	PSW
	Pop	ACC
	Jc	CekAkhirPerintah
	Clr	C
	Ret

CekAkhirPerintah:
	Jnz	LoopFindPerintah
	Setb	C
	Ret
	
TabelPerintah:
	DB	'CEK_I/O         '
	DB	'SET_TIME        '
	DB	'VIEW_TIME       '
	DB	'SETTING         '
	DB	'VIEW_SETTING    '
	DB	'PULSA           '
	DB	'RESET           '
	DB	'OPERATOR        '
	DB	'COMPANY         '
	DB	'I/O=            '
	DB	'VIEWID          '
	DB	'SETSUHU         '
	DB	'SETARUS         '
	DB	'POSISI          '
	DB	0

InitGSM:
;	Mov	DPTR,#PesanAT
;	Lcall	KirimPesan_Serial
;	Lcall	WaitOK
	Mov	DPTR,#PesanSetSilent
	Lcall	KirimPesan_Serial
	Lcall	WaitOK
	Mov	DPTR,#PesanSetASCIIMode
	Lcall	KirimPesan_Serial
	Lcall	WaitOK
;	Mov	DPTR,#PesanSetEchoOFF
;	Lcall	KirimPesan_Serial
;	Lcall	WaitOK

LoopCreg:

	Push	IE
	Clr	EA
	Clr	TF0
	Lcall	Delay_1detik
	Pop	IE

	Mov	DPTR,#PesanCREG
	Lcall	KirimPesan_Serial

LoopCreg2:
	Mov	DPTR,#CekCREG
	Lcall	CompareSerial

	Jc	LoopCReg2

	Lcall	Serial_In
	Push	ACC
	Push	PSW
	Lcall	TungguEnter
	Lcall	WaitOK
	Pop	PSW
	Pop	ACC
	Jc	LoopCreg

	Cjne	A,#'1',CekCreg5


	Ret




CekCreg5:
	Cjne	A,#'5',LoopCreg
	Ret

CekCREG:
	DB	'+CREG: 0,',0


WaitOK:

	Lcall	Serial_In

	Cjne	A,#'O',CekE
	
	Lcall	Serial_In

;	Cjne	A,#'K',WaitOK
	Ret

WaitOK2:
	Mov	B,#0
LoopWaitOK:
	Lcall	SerialInTout
	Cjne	A,#'O',CekOKTout
	Lcall	SerialInTout
	Ret

CekOKTout:
	Djnz	B,LoopWaitOK	
	Lcall	SerialInTout
	Ret


CekE:
	Cjne	A,#'E',CekS
	Lcall	Serial_In
	Lcall	Serial_In
	Lcall	Serial_In
	Lcall	Serial_In
	Ret

CekS:
	Cjne	A,#'s',WaitOK
	Setb	RI
	Setb	EA
	Setb	ES
	Ret

PesanAT:
	DB	'AT',0Dh,0Ah,0Fh

PesanSetEchoOFF:
	DB	'ATE0',0Dh,0Ah,0Fh

PesanSetASCIIMode:
	DB	'AT+CMGF=1',0Dh,0Ah,0Fh

PesanSetSilent:
	DB	'AT+CALM=1',0Dh,0Ah,0Fh

PesanCreg:
	DB	'AT+CREG?',0Dh,0Ah,0Fh

;=====================================================================
; COMPARE DATA SERIAL DENGAN FIX DATA
; - Bandingkan data serial dengan fix data
; - Bila ketemu akhiran, berarti match dan clear carry flag
; - Bila ada yang tidak sama, berarti tidak match dan set carry flag

SerialIn:
	Push	B
	Clr	RI
	Mov	B,#0
LoopSerial:
	Jnb	RI,CekDelay
	Mov	A,SBUF
OutSerialIn:
	Clr	RI
	Pop	B
	Ret

CekDelay:	
	Djnz	B,LoopSerial
	Mov	A,#00
	Ljmp	OutSerialIn


;==================================================================
; COMPARE SERIAL DENGAN DATA DI DPTR dengan data serial yang masuk
; - Bila ketemu akhiran berarti match, carry flag clear
; - Bila tidak berarti not match, carry flag set


CompareSerial:
;	Mov	R0,#BufferOutbox

CompareSerials:
	Mov	A,#00
	Movc	A,@A+DPTR
;	Mov	@R0,A
;	Inc	R0
	Jz	CompareMatch
	Inc	DPTR
	Mov	B,A
	Lcall	Serial_In
	Clr	C	
	Subb	A,B
	Jnz	CompareNotMatch	
	Ljmp	CompareSerials

CompareNotMatch:

	Setb	C
	Ret

CompareMatch:
	Clr	C
	Ret

CompareSEERAM:
	Lcall	BacaEEPROM

;	lcall	serial_out
	Jz	CompareMatch
	Inc	DPTR
	Mov	B,A
	Mov	A,@R0
	Inc	R0
	Clr	C	
	Subb	A,B
	Jnz	CompareSEENotMatch	
	Ljmp	CompareSEERAM

CompareSEENotMatch:
	Setb	C
	Ret

CompareSEEMatch:
	Clr	C
	Ret


CekNomorHP:
	Mov	R5,#JumlahHP
	Mov	DPTR,#NomorHPOwner

LoopCekNoHP:
	Push	DPH
	Push	DPL
	Mov	R0,#BufferHPTujuan
	Mov	A,@R0
	Cjne	A,#'+',BukanInternasional
	Inc	R0		;abaikan +
	Inc	R0		;abaikan 6
	Inc	R0		;abaikan 2
	Inc	DPTR		;abaikan 0 pada memori

BukanInternasional:
	Lcall	BacaEEPROM
	Setb	C
	Jz	HPTidakAda

	Lcall	CompareSEERAM
HPTidakAda:
	Pop	DPL
	Pop	DPH	
	Jnc	HPKetemu

	Mov	A,#KapasitasField
	Lcall	AddADPTR
	Djnz	R5,LoopCekNoHP
	Setb	C
	Ret

HPKetemu:
	Clr	C
	Ret

;===========================================================================
; BAGIAN PENCARI INDEKS PERINTAH IO
; - Bila index ketemu = carry flag clear dan nilai index ada di indexperintah dalam hex
; - Bila tidak ketemu = carry flag set

CariIndeksIO:
	Mov	DPTR,#PesanRelayON
	Mov	IndexPerintah,#0	
	Mov	R5,#JumlahIO*2

LoopFindIO:
	Mov	R0,#BufferPerintah
	Mov	R7,#16
	Lcall	CompareSEEString

	Inc	IndexPerintah
	Push	ACC
	Push	PSW
	Mov	A,#KapasitasField
	Lcall	AddADPTR
	Pop	PSW
	Pop	ACC
	Jc	CekAkhirIO
	Clr	C
	Ret

CekAkhirIO:
	Djnz	R5,LoopFindIO
	Setb	C
	Ret
