	CSEG
	Org	$
JumlahDataDefault	EQU	00		;Jumlah ini harus sesuai dengan
Jumlah2DataDefault	EQU	146		;jumlah data di tabel default

;=========== SET DEFAULT
SetDefault:
	Mov	DPTR,#ID			;PTR = Alamat awal EEPROM
	Mov	PTR+1,DPH			;
	Mov	PTR,DPL				;
	Mov	DPTR,#TabelDefault		;DPTR = Alamat awal Data Default
	Mov	R7,#JumlahDataDefault		;512 byte
	Lcall	CopyTabelkeEEPROM		;
	Mov	R7,#JumlahDataDefault		;
	Lcall	CopyTabelkeEEPROM		;


	Mov	R7,#Jumlah2DataDefault
	Lcall	CopyTabelkeEEPROM
	Ret

ReloadSetting:
	Mov	DPTR,#MemDelaySampling
	Lcall	BacaEEPROM			;
	Mov	SamplingTime,A			;
	Mov	DPTR,#MemIOStatus			;
	Lcall	BacaEEPROM			;
	Orl	A,#11111000b
	Mov	P0,A				;
	Mov	DPTR,#FlagAlarm
	Lcall	BacaEEPROM
	Mov	C,ACC0
	Mov	EX0,C
	Mov	C,ACC1
	Mov	EX1,C
	Inc	DPTR
	Lcall	BacaEEPROM
	Mov	PrescaleTimer,A	

	Ret


TabelDefault:	
	DB	0
	DB	0
	DB	'0816534847'		;No HP Default
	DB	0,0,0,0,0,0,0,0,0,0	;Akhiran dan reseve no HP
	DB	0,0,0,0,0,0,0,0,0,0	;Operator number (reset)

	DB	'0816534847'		;User 1
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 2
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 3
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 4
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 5
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 6
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 7
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 8
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 9
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 10
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 11
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 12
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 13
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 14
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 15
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 16
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 17
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 18
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 19
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0	;User 20
	DB	0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Relay ON 1
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Relay ON 2
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Relay ON 3
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Relay ON 4
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Relay ON 5
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Relay ON 6
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Relay ON 7
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Relay ON 8
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Relay OFF 1
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Relay OFF 2
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Relay OFF 3
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Relay OFF 4
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Relay OFF 5
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Relay OFF 6
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Relay OFF 7
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Relay OFF 8
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Alarm 1
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0		;Pesan Alarm 2

	DB	1			;Delay Sampling 1 detik
	DB	05			;Default setting warning suhu 50 derajat
	DB	05			;Default setting warning suhu 50 derajat
	DB	05			;Default setting warning suhu 50 derajat
	DB	05			;Default setting warning suhu 50 derajat
	DB	ToleransiSuhu		;Default setting toleransi suhu	
	DB	ToleransiSuhu		;Default setting toleransi suhu	
	DB	ToleransiSuhu		;Default setting toleransi suhu	
	DB	ToleransiSuhu		;Default setting toleransi suhu	

	DB	00,00,00,00		;Zero offset 4 kanal suhu
	DB	PembagiSuhu		;Default kalibrasi suhu 1
	DB	PembagiSuhu		;Default kalibrasi suhu 2
	DB	PembagiSuhu		;Default kalibrasi suhu 3
	DB	PembagiSuhu		;Default kalibrasi suhu 4
	DB	0FFh			;Default I/O Status OFF
	DB	0FCh			;Default Flag Alarm
	DB	200			;Default Prescaler


JumlahHP	EQU	20
KapasitasField	EQU	16
JumlahIO	EQU	8
JumlahAlarm	EQU	2
ToleransiSuhu	EQU	3
PembagiSuhu	EQU	1

;DATA DI EEPROM
;Susunan harus sama dengan susunan di tabel default.
;Bila ingin menambah, tambahkan dibawahnya

	DSEG
	Org	00
ID:			Ds	2
HPServer:		Ds	20
OperatorNumber:		Ds	10
NomorHPOwner:		Ds	KapasitasField*JumlahHP
PesanRelayON:		Ds	16*16
PesanAlarm:		Ds	16*2
MemDelaySampling:	Ds	1
MemSuhuSetting:		Ds	4
MemToleransiSuhu:	Ds	4
MemZeroSuhu:		Ds	4
MemPembagiSuhu:		Ds	4
MemIOStatus:		Ds	1
FlagAlarm:		Ds	1
MemPrescale:		Ds	1













