        DSEG
Counter_5ms:     Ds      1               ;Jumlah delay 5mS yg terjadi

        CSEG
        Org     $
;************
;* Delay 5 mS sebanyak 200 x

Delay_1detik:
	Mov	Counter_5mS,#0200		

Tunggu_1detik:
        Lcall   Delay_5mS
	Djnz	Counter_5mS,Tunggu_1detik
	Ret
	
;***********
;* Delay 5 mS sebanyak 100 x

Delay_500mS:
	Mov	Counter_5mS,#0100

Tunggu_500mS:
        Lcall   Delay_5mS
	Djnz	Counter_5mS,Tunggu_500mS
	Ret

;************
;* Delay 5 mS sebanyak 20 x

Delay_100mS:
	Mov	Counter_5mS,#020

Tunggu_100mS:
        Lcall   Delay_5mS
	Djnz	Counter_5mS,Tunggu_100mS
	Ret

;************
;* Delay 5 mS sebanyak 15 x

Delay_75mS:
	Mov	Counter_5mS,#015

Tunggu_75mS:
        Lcall   Delay_5mS
	Djnz	Counter_5mS,Tunggu_75mS
	Ret

;**************
;* Delay ini bekerja hanya pada crystal 11.0592 MHz

Delay_50mS:
	Push	07H
	Mov	R7,#10
loopdelays:
	Lcall	Delay_5mS
	Djnz	R7,Loopdelays
	Pop	07H
	Ret

;**************
;* Delay ini bekerja hanya pada crystal 11.0592 MHz

Delay_5mS:
	Push	TMOD
	Mov	TMOD,#21H		;Timer Mode 16 bit counter
	Mov	TH0,#0EDH
	Mov	TL0,#0FFH
	Setb	TR0

Tunggu_5mS:
	Jbc	TF0,Sudah_5mS
        Ljmp    Tunggu_5mS 

Sudah_5mS:
	Clr	TR0
	Pop	TMOD
	Ret
