ResetMemori:
LoopResetMemori:
	Push	07
	Mov	A,#00	
	Lcall	TulisEEPROM
	Inc	DPTR
	Pop	07
	Djnz	R7,LoopResetMemori
	Ret


CopyTabelkeEEPROM:
LoopCopyDefault:
	Mov	A,#00				;Ambil dari tabel dan save ke memori
	Movc	A,@A+DPTR			;
	Push	DPH				;
	Push	DPL				;
	Mov	DPH,PTR+1			;
	Mov	DPL,PTR				;
	Lcall	TulisEEPROM			;
	Inc	DPTR				;
	MOv	PTR+1,DPH			;
	Mov	PTR,DPL				;
	Pop	DPL				;
	Pop	DPH				;
	Inc	DPTR
	Djnz	R7,LoopCopyDefault	
	Ret


CopyEEPROMkeRAM:
LoopCopyEEPROMRAM:
	Lcall	BacaEEPROM
	Inc	DPTR
	Mov	@R0,A
	Inc	R0
	Jnz	LoopCopyEEPROMRAM
	Mov	@R0,A
	Ret


CopyTabelkeRAM:
LoopCopyTabelRAM:
	Mov	A,#00
	Movc	A,@A+DPTR
	Inc	DPTR
	Mov	@R0,A
	Inc	R0
	Jnz	LoopCopyTabelRAM
	

	Ret

;=============================================================================

; RUTIN PENULISAN DATA KE EEPROM INTERNAL AT89S8253
;- Pointer DPTR
;- Data di akumulator

TulisEEPROM:
	Mov	EECON,#00001000b	;Set EEMEN
	Nop	
	Mov	EECON,#00011000b	;Set EEMWE
	Movx	@DPTR,A
	Lcall	TungguTulis
	Mov	EECON,#00001000b
	Ret	


;=============================================================================
; RUTIN PENULISAN DATA KE EEPROM INTERNAL AT89S8253 MODE PAGE
;- Pointer DPTR
;- Data di R0
;- Jumlah data di R7

TulisEEPROMPage:
	Mov	EECON,#00001000b	;Set EEMEN
	Nop	
	Mov	EECON,#00011000b	;Set EEMWE
	Nop
	Mov	EECON,#00111000b	;Set EELD
LoopTulisEEPROMPage:
	Mov	A,@R0
	Inc	R0
	Movx	@DPTR,A
	Inc	DPTR

	Djnz	R7,LoopTulisEEPROMPage

	Mov	EECON,#00011000b	;Clear EELD
	Mov	A,@R0
	Movx	@DPTR,A
	Lcall	TungguTulis
	Ret
	

TungguTulis:
	Mov	WDT,#11111011b
	Mov	0A6h,#01eh
	Mov	0A6h,#0E1h
	Mov	A,EECON
	Jb	ACC1,TungguTulis

TungguTulis2:
	Mov	WDT,#11111011b
	Mov	0A6h,#01eh
	Mov	0A6h,#0E1h
	Mov	A,EECON
	Jnb	ACC1,TungguTulis2
	Ret

;=============================================================================

; BACA DATA EEPROM AT89S8253
;- Pointer: DPTR
;- Data di akumulator

BacaEEPROM:
	Mov	EECON,#00001000b
	Movx	A,@DPTR
	Ret	